/* Conceptos
 - Strings
 - const
 - Pass by reference
 */
#include <stdio.h>
#include <stdlib.h>

#define MAXLINE 1000

/*
 * arrays passed by reference
 * const function parameters possible
 */
/* there is no String datatype
 * strings = arrays of characters
 * end of the string = character '\0'
 * "foo" == ['f','o','o','\0']
 *
 * 'x' != "x" 
 */
void copy(char to[], const char from[]){
	int i;
	
	/* note empty body */
	for(i=0; (to[i]=from[i])!='\0'; ++i)
		;
}

/*
 * read line of maximum lim length
 * need lim to ensure we never write outside the array
 * c does not guarantee any checks for buffer overflow! 
 */
int getline(char s[], int lim) {
	int c, i;
	
	for(i=0; i<lim-1 && (c=getchar())!=EOF && c!='\n'; ++i)
		s[i]=c;
	if(c=='\n')	{
		s[i]=c;
		++i;
	}
	s[i]='\0';
	
	return i;
}

int main() {
	int size, maxsize;
	char line[MAXLINE], biggest[MAXLINE];
	
	maxsize=0;
	/*
	 * if size == 0 then EOF.
	 * empty line = '\n', so size == 1
	 */
	while((size=getline(line, MAXLINE))>0)
		if(size>maxsize){
			maxsize=size;
			copy(biggest, line);
		}
	
	printf("The biggest line is:\n%s\n", biggest);
	
	return(EXIT_SUCCESS);
}
