/* Conceptos:
 - External variables
 - External variable definition versus variable declaration
 */
#include <stdio.h>
#include <stdlib.h>

#define MAXLINE 1000

/* 
 * external variables
 * global scope!
 * usually put in header file, see later
 */
char line[MAXLINE], biggest[MAXLINE];

void copy(){
	int i;

	extern char line[];
	extern char biggest[];
	
	for(i=0; (biggest[i]=line[i])!='\0'; ++i)
		;
}

int getline() {
	int c, i;
	
	for(i=0; i<MAXLINE-1 && (c=getchar())!=EOF && c!='\n'; ++i)
		line[i]=c;
	if(c=='\n')	{
		line[i]=c;
		++i;
	}
	line[i]='\0';
	
	return i;
}

int maxsize;

int main() {
	int size;

	/*
	 * not needed: not an array + declared before the function.
	 * BUT best is to always add it
	 */
	extern int maxsize;
	maxsize=0;
	
	while((size=getline())>0)
		if(size>maxsize){
			maxsize=size;
			copy();
		}
	
	printf("The biggest line is:\n%s\n", biggest);
	
	return(EXIT_SUCCESS);
}