/* Conceptos
 - Pointers ! (punteros)
 - Pointer dereferencing
 */ 
#include <stdio.h>
#include <stdlib.h>

/*
 * takes memory addresses = pointers 
 * pointers also passed by copy
 * the value at the address is passed by reference !
 */
void swap(int *from, int *to){
	int temp;
	
	temp = *to;
	*to = *from;
	*from = temp;
}

/*
 * This does nothing!
 */
void noswap(int *from, int *to){
	/*
	 * pointers can be set and compared to 0
	 * pointers of same type can be assigned
	 */
	int *temp = 0;
	
	temp = to;
	to = from;
	from = temp;
}

int main (){
	int a = 42, b = 69;
	
	printf("Before swap: a = %d, b = %d\n",a,b);
	
	/*
	 * & unary operator
	 * takes the memory address of the argument
	 */
	swap(&a, &b);
	
	printf("After swap: a = %d, b = %d\n",a,b);

	noswap(&a, &b);
	
	printf("After noswap: a = %d, b = %d\n",a,b);
	
	
	return(EXIT_SUCCESS);
}
