/* Conceptos:
 - Pointers versus arrays
 - Pointer arithmetic
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int string_length_1(const char *string){
	int count;
	/*
	 * pointers can be incremented and decremented
	 * string[n] = *(string + n)
	 */
	for (count = 0; *string!='\0'; string++,count++); 
	
	return count;
}

int string_length_2(const char *string){
	char *begin = 0;
	begin = string;
	
	while (*string!='\0')
		string++; 
	/*
	 * if in the same array pointer + -  and == != < >= ...  is allowed
	 */
	return string - begin;
}


int main (){
	/*
	 * arrays = consecutive memory locations
	 * strings = character arrays = consecutive memory locations with characters in them
	 * char *foo = pointer to the first element of the string foo
	 *
	 * arrays are actually pointers. equivalent lines:
	 * int a[3]; int *p; p = &a[0];
	 * int a[3]; int *p; p = a;
	 */
	char *thestring = "The long, dark tea time of the soul.";
	
	printf("Length of \'%s\'= %d (strlen)\n", thestring, strlen(thestring));
	printf("Length of \'%s\'= %d (string_length_1)\n", thestring, string_length_1(thestring));
	printf("Length of \'%s\'= %d (string_length_2)\n", thestring, string_length_2(thestring));

	return(EXIT_SUCCESS);
}