/* Conceptos:
 - Bitwise operators
 - Mask bits
 - Hexadecimal numbers
 */
#include <stdio.h>
#include <stdlib.h>

char tolowercase(char c){
	/*
	 * bitwise operators
	 * & and
	 * | or
	 * ^ xor
	 * ~ bitwise not
	 */
	/* 
	 * (c |= 0x20) == (c += 0x20) in this case
	 * x |= MASK  : turn bits in MASK on
	 * x &= ~MASK : turn bits in MASK off
	 * x &= MASK  : filter using MASK
	 */
	if(c>='A' && c<='Z')
		c = c | 0x20;
	return c;
}

int main(){
	/*
	 * Hexadecimal notation = 2 digits per byte
	 * closest to machine architecture - used a lot
	 * digits: 0 1 2 3 4 5 6 7 8 9 a b c d e f
	 *
	 * hex -> decimal examples:
	 * 1 in hex = 0x1 = '\x01' = 1 in decimal
	 * a in hex = 0xa = '\x0a' = 10 in decimal
	 * 91 in hex = 0x91 = '\x91' = 9*16 + 1 = 145 in decimal
	 * 5a in hex = 0x5a = '\x5a' = 5*16 + 10 = 90 in decimal
	 * 420 in hex = 0x420 = 4*16*16 + 2*16 + 0 = 1056 in decimal
	 * easy trick: printf("%d",0x91);
	 */
	printf("char a = number 0x%x, char z = number 0x%x\nchar A = number 0x%x, char Z = number 0x%x\n",'a','z','A','Z');
	printf("tolowercase('F') = %c\n", tolowercase('F'));
	return(EXIT_SUCCESS);
}